/* Fotografie Webseite
2011 - Thomas Schmidt
http://netaction.de
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
http://creativecommons.org/licenses/by-sa/3.0/
*/


// globals
var oldHash = 'old';
var active,element,mouseX;
var oldHeight,oldWidth; // size of the viewport

function scroller() {
  var x = (mouseX - element.offset().left) / element.width() - 0.5;
  x=Math.round(x*x*x*60);

  element.scrollLeft(element.scrollLeft()+x);
} // scroller


function checkHash() {
  if(window.location.hash.slice(1) != oldHash) { // URL changed
    switch (oldHash) {
      case "about":$('#about').fadeOut(); break;
      case "references":$('#references').fadeOut(); break;
      case "contact":$('#contact').fadeOut(); break;
    }

    oldHash = window.location.hash.slice(1); // set current hash as known hash
    switch (oldHash) {
      case "about":$('#about').fadeIn(); break;
      case "references":$('#references').fadeIn(); break;
      case "contact":$('#contact').fadeIn(); break;
    }
  }
} // checkHash


function checkWindowsize() {
  var height = $(window).height();
  height -= 240; // header and thumbnails
  var width = $(window).width();
  if ((width!=oldWidth) || (height!=oldHeight)) {
    oldHeight=height;
    oldWidth=width;
    if (width<510) width=510;
    if (height<340) height=340;
    // set big image to 2/3 aspect ratio:
    if (height*3<width*2) { // too wide
      $('.gallery').css('left',(width-height*3/2)/2);
      if (height*3/2<800) $('h1,div#subtitle,#gallery-change').css('left',0);
      else $('h1,div#subtitle,#gallery-change').css('left',(width-height*3/2)/2);
      if (height*3/2<800) $('#navi').css('right',0);
      else $('#navi').css('right',(width-height*3/2)/2);
      width=height*3/2;
    }
    else { // too high
     height=width*2/3;
      $('.gallery').css('left',0);
      $('h1,div#subtitle,#gallery-change').css('left',0);
      $('#navi').css('right',0);
    }
    $('.gallery').height(height+140);
    $('.gallery').width(width);
    $('.gallery-big').width(width);
    $('.gallery-big').height(height);
  }
} // checkWindowsize

function loadGallery() {
  $('img.gallery-big').attr('src',$('div.gallery-list').children(':first').attr('href'));
  $('.gallery .gallery-list a').mouseover(function() {  // load big image
    $(this).parent().parent().children(':first').attr('src',$(this).attr('href'));
  });
  $('.gallery .gallery-list a').click(function() {  // disable mouseclick
    return false;
  });
  $('#gallery-change div').removeClass('active');
}

$(function() {
  $('.gallery .gallery-list').mousemove( function(e) { mouseX = e.pageX; });
  $('.gallery .gallery-list').css('white-space','nowrap').css('overflow','hidden');
  $('.gallery .gallery-list').mouseenter(function() {  // start scrolling
    element=$(this);
    active=setInterval('scroller()', 20);
  });
  $('.gallery .gallery-list').mouseleave(function() {  // stop scrolling
    clearInterval(active);
  });


  $('#gallery1').click(function(){
    $('div.gallery-list').html($('#gallery1-list').html()).scrollLeft(0);
    loadGallery();
    $(this).addClass('active');
  }).click();
  $('#gallery2').click(function(){
    $('div.gallery-list').html($('#gallery2-list').html()).scrollLeft(0);
    loadGallery();
    $(this).addClass('active');
  });
  $('#gallery3').click(function(){
    $('div.gallery-list').html($('#gallery3-list').html()).scrollLeft(0);
    loadGallery();
    $(this).addClass('active');
  });
  $('#gallery4').click(function(){
    $('div.gallery-list').html($('#gallery4-list').html()).scrollLeft(0);
    loadGallery();
    $(this).addClass('active');
  });
  $('#gallery5').click(function(){
    $('div.gallery-list').html($('#gallery5-list').html()).scrollLeft(0);
    loadGallery();
    $(this).addClass('active');
  });


  setInterval("checkHash()",100);
  setInterval("checkWindowsize()",100);
});
